      SUBROUTINE UMAT(STRESS,STATEV,DDSDDE,SSE,SPD,SCD,
     1 RPL,DDSDDT,DRPLDE,DRPLDT,
     2 STRAN,DSTRAN,TIME,DTIME,TEMP,DTEMP,PREDEF,DPRED,CMNAME,
     3 NDI,NSHR,NTENS,NSTATV,PROPS,NPROPS,COORDS,DROT,PNEWDT,
     4 CELENT,DFGRD0,DFGRD1,NOEL,NPT,LAYER,KSPT,KSTEP,KINC)
C
      INCLUDE 'ABA_PARAM.INC'
C
      real :: EMOD,ENU,EBULK3,EG2,EG,EG3,ELAM
      real :: r,Residual,Mat,LSTR,Str,S,ANPS,PS,X,Y 
      integer :: K1,K2
      CHARACTER*80 CMNAME
      DIMENSION STRESS(NTENS),STATEV(NSTATV),
     1 DDSDDE(NTENS,NTENS),DDSDDT(NTENS),DRPLDE(NTENS),
     2 STRAN(NTENS),DSTRAN(NTENS),TIME(2),PREDEF(1),DPRED(1),
     3 PROPS(NPROPS),COORDS(3),DROT(3,3),DFGRD0(3,3),DFGRD1(3,3),
     4 Str(3,3),S(4),ANPS(3,3),PS(3),X(4),Y(3,3)
      
      DIMENSION EELAS(6),EPLAS(6),FLOW(6),Mat(3,3),Residual(3,3)
      PARAMETER (ONE=1.0D0,TWO=2.0D0,THREE=3.0D0,SIX=6.0D0)
      DATA NEWTON,TOLER/10,1.D-6/
C
C -----------------------------------------------------------
C     UMAT FOR ISOTROPIC ELASTICITY AND ISOTROPIC PLASTICITY
C     J2 FLOW THEORY
C     CAN NOT BE USED FOR PLANE STRESS
C -----------------------------------------------------------
C     PROPS(1) - E
C     PROPS(2) - NU
C     PROPS(3) - SYIELD
C     CALLS AHARD FOR CURVE OF SYIELD VS. PEEQ
C -----------------------------------------------------------
C

    !This code is written to simulate Isotropic Isothermal Elasticity, which is nothing but uniform elastic model from Abaqus
       !PROPS(1) = E; Young's modulus of the material
       !PROPS(2) = nu; Poission's ratio of the material
    !Please note this code is not applicable for plane stress conditions as the stiffness matrix is different for them
       !if (NDI/=3) then
        !   write(7,*) 'This UMAT only be used for elements with 3D'
         !  call XIT
       !endif
    
       !Elastic Properties definition
      ! r = sqrt(COORDS(1)**2 + COORDS(2)**2)
       !if (r<=14.7) then
           !EMOD=(230-(30/1.5)*(r-13.2))*10**3
           !EMOD=200*10**3
           !EMOD=156.66*10**3
        !   EMOD=215.66*10**3
       !else
        !   EMOD=PROPS(1)
       !endif
       
       EMOD=PROPS(1)
       ENU=PROPS(2)
       EBULK3=EMOD/(1-2*ENU)
       EG2=EMOD/(1+ENU)
       EG=EG2/2
       EG3=3*EG
       ELAM=(EBULK3-EG2)/3
       
       do K1= 1, NDI
           do K2= 1,NDI
               DDSDDE(K2,K1)=ELAM
           end do
           DDSDDE(K1,K1)=EG2+ELAM
       end do
       do K1= NDI+1, NTENS
           DDSDDE(K1,K1)=EG
       end do
       
       !This part calculates stress based on element stiffness matrix and engineering strain
       do K1=1, NTENS
           do K2=1, NTENS
               STRESS(K2)=STRESS(K2)+DDSDDE(K2,K1)*DSTRAN(K1)
           end do
       end do
       LSTR=1
      !CALL SINV(STRESS,SINV1,SINV2,NDI,NSHR)
       S=STRESS
       !CALL SPRINC(S,PS,LSTR,NDI,NSHR)
      CALL SPRIND(S,PS,ANPS,LSTR,NDI,NSHR)
       !Mat=Transpose(ANPS)
       !Residual(:,:)=0.0
       !if (ABS(PS(1))>=ABS(PS(2)) .AND. ABS(PS(1))>=ABS(PS(3))) then
       !Residual(2,2)=-400
       !Residual(3,3)=-400
      !elseif (ABS(PS(2))>=ABS(PS(1)) .AND. ABS(PS(2))>=ABS(PS(3))) then
       !Residual(1,1)=-400
       !Residual(3,3)=-400   
      !elseif (ABS(PS(3))>=ABS(PS(1)) .AND. ABS(PS(3))>=ABS(PS(2))) then 
       !Residual(1,1)=-400
      ! Residual(2,2)=-400
      !endif
      
      ! Y=MATMUL(Residual,ANPS)
      ! Str=MATMUL(Mat,Y)
       !X(1)=Str(1,1)
      ! X(2)=Str(2,2)
      ! X(3)=Str(3,3)
       !X(4)=Str(1,2)
      ! STRESS=STRESS+X
       
      if(KSTEP>1 .AND. NOEL==1193) then 
      STRESS(1)=STRESS(1)-400
      STRESS(3)=STRESS(3)-400
      write(7,*) NOEL,NPT,PS(1),PS(2),PS(3),ANPS,STRESS
      endif
      
      RETURN
      END